
/*  d4delete.c   (C) Copyright Sequiter Software Inc., 1987-1990.  All rights reserved.

    d4delete()  -  Deletes a record.

    d4deleted() -  Returns '(int) 1' if the current record is deleted.
*/

#include "d4base.h"
#include "u4error.h"

extern  BASE  *v4base ;
extern  int    v4cur_base ;


int d4delete( long rec_num )
{
   int  rc ;

   if ( (rc = d4go(rec_num))  != 0)
	return( rc ) ;

   v4base[v4cur_base].buffer[0] =  '*' ;

   if ( d4write( rec_num )  < 0)
	return( -1 ) ;

   return( 0 ) ;
}


int d4deleted()
{
   if ( v4cur_base < 0 ) 
   {
      u4error( E_D_MISSING, (char *) 0 ) ; 
      return( -1 ) ;
   }
   if ( v4base[v4cur_base].buffer[0] == '*' )
	return( 1 ) ;
   else
	return( 0 ) ;
}
