
/*  (c)Copyright Sequiter Software Inc., 1987-1990.  All rights reserved.

    d4go.c
*/


#include "d4all.h"
#include "u4error.h"

extern BASE *v4base ;
extern int   v4cur_base ;


int d4go( long rec_num )
{
   BASE *base_ptr ;

   if ( v4cur_base < 0 )
   {
      u4error( E_D_MISSING, (char *) 0 ) ;
      return( -1 ) ;
   }

   if ( rec_num <= 0L )  
   {
      d4blank() ;
      return(1) ;
   }
   base_ptr =  v4base + v4cur_base ;

   #ifndef SMALL
      if ( d4changed(base_ptr) < 0 )  return -1 ;
   #endif

   v4base[v4cur_base].eof =  v4base[v4cur_base].bof =  0 ;

   return ( d4read( rec_num) ) ;
}
