
/* d4select.c   (c)Copyright Sequiter Software Inc., 1987-1990.  All rights reserved.

   Selects an database file for active use.
*/

#include "d4base.h"
#include "u4error.h"

extern  int    v4cur_base ;
extern  int    v4last_base ;
extern  BASE  *v4base ;


d4select( int base_ref )
{
   int on_base, previous_ref ;

   previous_ref =  v4cur_base ;

   on_base =  v4last_base ;
   while ( on_base >= 0)
   {
      if ( on_base == base_ref )
      {
	 v4cur_base =  base_ref ;
	 break ;
      }
      on_base =  v4base[on_base].prev ;
   }

   return( previous_ref ) ;
}


