
#include "d4base.h"
#include "w4.h"

int  b4quick_browse()
{
   int  c, j, next_c, w ;
   long ref ;

   w4define( 1,0,24,79 ) ;
   w4border( DOUBLE, F_WHITE ) ;
   w4title( 0,-1, d4name(), B_WHITE ) ;

   w4memory() ;
   w4activate(-1) ;
   g4release(0) ;

   next_c = 2 ;

   for ( j=1; j<=f4num_fields(); j++ )
   {
      c =  next_c ;

      ref =  f4j_ref(j) ;
      if ( f4type(ref) == 'M' ) continue ;
      if ( f4width(ref) >= MAX_GET_WIDTH ) continue ;

      w =  f4width(ref) ;
      if ( w <= 10 )  w = 10 ;

      next_c =  c+ w + 2 ;
      if ( next_c >= w4width(-1))  break ;

      w4 ( 1,c, f4name(ref) ) ;
      g4field( -1,c, ref ) ;
   }

   return( w4select(-1) ) ;
}

int  b4quick_edit()
{
   int  r, j ;
   long ref ;

   w4define( 1,0,24,79 ) ;
   w4border( DOUBLE, F_WHITE ) ;
   w4title( 0,-1, d4name(), B_WHITE ) ;

   w4memory() ;
   w4activate(-1) ;
   g4release(0) ;

   r = 1 ;
   for ( j=1; j<=f4num_fields(); j++ )
   {
      ref =  f4j_ref(j) ;
      if ( f4type(ref) == 'M' ) continue ;
      if ( f4width(ref) >= MAX_GET_WIDTH ) continue ;

      if ( r >= w4height(-1)-1 )  break ;
      w4 ( r,2, f4name(ref) ) ;
      g4field( r,14, ref ) ;
      if ( f4width(ref) > 64)  g4width( f4width(ref), 64 ) ;
      r++ ;
   }

   return( w4select(-1) ) ;
}
