
/* w4init_u.c  (c)Copyright Sequiter Software Inc., 1987-1990.  All rights reserved. */

#include "w4.h"
#include "d4all.h"
#include "h4memory.h"

extern CB_WINDOW *v4window ;
extern GET      *v4get ;
extern MENU     *v4menu ;

extern int       v4last_window ;
extern int       v4default_window ;


void  w4init_undo()
{
   while ( v4last_window >= 0 )  w4close( v4last_window ) ;
   v4default_window =  -1 ;

   if ( v4get != (GET *) 0 )
   {
      h4free_memory( (char *) v4get - sizeof(MEMORY) ) ;
      v4get =  (GET *) 0 ;
   }

   if ( v4menu != (MENU *) 0 )
   {
      h4free_memory( (char *) v4menu - sizeof(MEMORY) ) ;
      v4menu =  (MENU *) 0 ;
   }

   if ( v4window != (CB_WINDOW *) 0 )
   {
      h4free_memory( (char *) v4window - sizeof(MEMORY) ) ;
      v4window =  (CB_WINDOW *) 0 ;
   }

   return ;
}


